## kallisto 0.46.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(kallisto)

include(GNUInstallDirs)

set(EXT_PROJECTS_DIR ${PROJECT_SOURCE_DIR}/ext)
set(CMAKE_CXX_FLAGS_PROFILE "-g")

# Set Release type for builds where CMAKE_BUILD_TYPE is unset
# This is usually a good default as this implictly enables
#
#   CXXFLAGS = -O3 -DNDEBUG
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(${CMAKE_VERSION} VERSION_LESS 3.1)
    # CMake versions before 3.1 do not understand CMAKE_CXX_STANDARD
    # remove this block once CMake >=3.1 has fixated in the ecosystem
    add_compile_options(-std=c++11)
else()
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)
endif()

#add_compile_options(-Wall -Wno-unused-function)

if(LINK MATCHES static)
    message("static build")
ELSE(LINK MATCHES shared)
    message("shared build")
ENDIF(LINK MATCHES static)


include(ExternalProject)
ExternalProject_Add(htslib
    PREFIX ${PROJECT_SOURCE_DIR}/ext/htslib
    SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/htslib
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND autoheader && autoconf && ${PROJECT_SOURCE_DIR}/ext/htslib/configure 
        --prefix=${PREFIX} --disable-bz2 --disable-lzma --disable-libcurl
    BUILD_COMMAND make lib-static
    INSTALL_COMMAND ""
)

include_directories(${htslib_PREFIX}/src/htslib)



# add_compile_options(-Wdeprecated-register)

add_subdirectory(src)
include_directories(${EXT_PROJECTS_DIR})

option(BUILD_TESTING "Build unit tests." OFF)
include(CTest)

if (BUILD_TESTING)
    add_subdirectory(${EXT_PROJECTS_DIR}/catch)

    # Includes Catch in the project:
    include_directories(${CATCH_INCLUDE_DIR} ${COMMON_INCLUDES})

    add_subdirectory(unit_tests)
endif(BUILD_TESTING)

# enable_testing()
# add_test(MainTest test/tests)

=== src/CMakeLists.txt ===
file(GLOB sources *.cpp)
file(GLOB headers *.h *.hpp)

list(REMOVE_ITEM sources main.cpp)

include_directories(../ext/htslib)

add_library(kallisto_core ${sources} ${headers})
target_include_directories(kallisto_core PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(kallisto main.cpp)

find_package( Threads REQUIRED )
target_link_libraries(kallisto kallisto_core pthread ${CMAKE_CURRENT_SOURCE_DIR}/../ext/htslib/libhts.a)

if(LINK MATCHES static)
    set(BUILD_SHARED_LIBS OFF)
    set(HDF5_USE_STATIC_LIBRARIES 1)

    if (UNIX AND NOT APPLE)
        #set(CMAKE_EXE_LINKER_FLAGS  "-static -static-libgcc -static-libstdc++")
        set(CMAKE_EXE_LINKER_FLAGS  "-static -static-libstdc++")
        SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
        set(CMAKE_EXE_LINKER_FLAGS  "-static -static-libgcc -static-libstdc++")
    endif(UNIX AND NOT APPLE)

    SET_TARGET_PROPERTIES(kallisto kallisto_core PROPERTIES LINK_SEARCH_END_STATIC 1)
endif(LINK MATCHES static)

find_package( HDF5 REQUIRED )
find_package( ZLIB REQUIRED )

if ( ZLIB_FOUND )
    include_directories( ${ZLIB_INCLUDE_DIRS} )
else()
    message(FATAL_ERROR "zlib not found. Required for to output files" )
endif( ZLIB_FOUND )

if(HDF5_FOUND)
    include_directories( ${HDF5_INCLUDE_DIRS} )
    target_link_libraries( kallisto_core ${HDF5_LIBRARIES} )
    target_link_libraries( kallisto ${HDF5_LIBRARIES} )
else()
    message(FATAL_ERROR "HDF5 not found. Required to output files")
endif()


if(LINK MATCHES static)
    if (UNIX AND NOT APPLE)
        target_link_libraries(kallisto librt.a)
    endif()
else()
    if (UNIX AND NOT APPLE)
        target_link_libraries(kallisto rt)
    endif()
endif(LINK MATCHES static)


install(TARGETS kallisto DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== unit_tests/CMakeLists.txt ===
project(Tests)

# include_directories(../Catch/include)
# include_directories(../src)

file(GLOB sources *.cpp)

add_executable(tests ${sources})
add_test(unittest tests)

find_package( ZLIB REQUIRED )
if ( ZLIB_FOUND )
    include_directories( ${ZLIB_INCLUDE_DIRS} )
    target_link_libraries( tests ${ZLIB_LIBRARIES} )
endif( ZLIB_FOUND )

target_link_libraries(tests kallisto_core)

find_package( HDF5 REQUIRED )
if(HDF5_FOUND)
    include_directories( ${HDF5_INCLUDE_DIR} )
    target_link_libraries( tests ${HDF5_LIBRARIES} )
else()
    message(FATAL_ERROR "HDF5 not found. Required to output files")
endif()

## kallisto 0.45.1+dfsg

=== debian/changelog ===
kallisto (0.45.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #925417)

 -- Andreas Tille <tille@debian.org>  Sun, 24 Mar 2019 21:53:40 +0100

=== debian/control ===
Source: kallisto
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               libhdf5-dev,
               libhts-dev
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/kallisto
Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
Homepage: https://pachterlab.github.io/kallisto

Package: kallisto
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: near-optimal RNA-Seq quantification
 Kallisto is a program for quantifying abundances of transcripts from
 RNA-Seq data, or more generally of target sequences using high-throughput
 sequencing reads. It is based on the novel idea of pseudoalignment for
 rapidly determining the compatibility of reads with targets, without the
 need for alignment. On benchmarks with standard RNA-Seq data, kallisto
 can quantify 30 million human reads in less than 3 minutes on a Mac
 desktop computer using only the read sequences and a transcriptome index
 that itself takes less than 10 minutes to build. Pseudoalignment of
 reads preserves the key information needed for quantification, and
 kallisto is therefore not only fast, but also as accurate than existing
 quantification tools. In fact, because the pseudoalignment procedure is
 robust to errors in the reads, in many benchmarks kallisto significantly
 outperforms existing tools.

Package: kallisto-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: kallisto
Suggests: snakemake
Description: near-optimal RNA-Seq quantification (example data)
 Kallisto is a program for quantifying abundances of transcripts from
 RNA-Seq data, or more generally of target sequences using high-throughput
 sequencing reads. It is based on the novel idea of pseudoalignment for
 rapidly determining the compatibility of reads with targets, without the
 need for alignment. On benchmarks with standard RNA-Seq data, kallisto
 can quantify 30 million human reads in less than 3 minutes on a Mac
 desktop computer using only the read sequences and a transcriptome index
 that itself takes less than 10 minutes to build. Pseudoalignment of
 reads preserves the key information needed for quantification, and
 kallisto is therefore not only fast, but also as accurate than existing
 quantification tools. In fact, because the pseudoalignment procedure is
 robust to errors in the reads, in many benchmarks kallisto significantly
 outperforms existing tools.
 .
 This package contains usage examples which are used in autopkgtest.

## kallisto 0.46.0+dfsg

=== debian/changelog ===
kallisto (0.46.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0

 -- Andreas Tille <tille@debian.org>  Wed, 07 Aug 2019 13:01:05 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libhdf5-dev,
                libhts-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/kallisto
 Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
 Homepage: https://pachterlab.github.io/kallisto

## kallisto 0.46.1+dfsg

=== debian/changelog ===
kallisto (0.46.1+dfsg-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:16:54 +0100

kallisto (0.46.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * mark kallisto-examples as Multi-Arch: foreign
  * debian/patches/spelling: fix typo
  * debian/patches/htslib1.3: use kseq.h from htslib, not the bundled version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 25 Dec 2019 12:05:55 +0100

kallisto (0.46.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Fri, 08 Nov 2019 23:14:36 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                cmake,
                libhdf5-dev,
                libhts-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/kallisto
 Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
 Homepage: https://pachterlab.github.io/kallisto
@@ -35,6 +35,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Recommends: kallisto
+Multi-Arch: foreign
 Suggests: snakemake
 Description: near-optimal RNA-Seq quantification (example data)
  Kallisto is a program for quantifying abundances of transcripts from

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CMAKE_EXTRA_FLAGS += -DDEBIAN_BUILD=1 \
                     -DLINK=shared

# Build time test requires https://github.com/philsquared/Catch
#                     -DBUILD_TESTING=ON \

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	do_stuff_for_testing
#endif

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz" \
  https://github.com/pachterlab/kallisto/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## kallisto 0.46.2%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,13 @@
 project(kallisto)
 
 include(GNUInstallDirs)
+
+
+option(USE_HDF5 "Compile with HDF5 support" OFF) #OFF by default
+
+if(USE_HDF5)
+    add_compile_definitions("USE_HDF5=ON")
+endif(USE_HDF5)
 
 set(EXT_PROJECTS_DIR ${PROJECT_SOURCE_DIR}/ext)
 set(CMAKE_CXX_FLAGS_PROFILE "-g")

=== debian/changelog ===
kallisto (0.46.2+dfsg-3) unstable; urgency=medium

  * Team Upload.
  * debian/patches/gcc11.patch: Fix gcc-11 FTBFS (Closes: #984073)

 -- Nilesh Patra <nilesh@debian.org>  Thu, 04 Mar 2021 23:54:34 +0530

kallisto (0.46.2+dfsg-2) unstable; urgency=medium

  * Team upload
  * Patch to avoid segfault (Closes: #960368)

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Sat, 16 May 2020 04:47:12 +0530

kallisto (0.46.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete field Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Steffen Moeller <moeller@debian.org>  Fri, 15 May 2020 13:12:09 +0200

## kallisto 0.46.2+dfsg

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,11 @@
                cmake,
                libhdf5-dev,
                libhts-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/kallisto
 Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
 Homepage: https://pachterlab.github.io/kallisto
+Rules-Requires-Root: no
 
 Package: kallisto
 Architecture: any

## kallisto 0.48.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -74,5 +74,16 @@
     add_subdirectory(unit_tests)
 endif(BUILD_TESTING)
 
+option(BUILD_FUNCTESTING "Build functional tests." OFF)
+
+if (BUILD_FUNCTESTING)
+    add_subdirectory(func_tests)
+    message("Functional testing enabled.")
+    add_custom_target(test
+    COMMAND /bin/bash ./func_tests/runtests.sh
+    DEPENDS ./src/kallisto
+    )
+endif(BUILD_FUNCTESTING)
+
 # enable_testing()
 # add_test(MainTest test/tests)

=== func_tests/CMakeLists.txt ===
project(FuncTests)

file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/runtests.sh
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -27,23 +27,29 @@
     SET_TARGET_PROPERTIES(kallisto kallisto_core PROPERTIES LINK_SEARCH_END_STATIC 1)
 endif(LINK MATCHES static)
 
-find_package( HDF5 REQUIRED )
+
+if(USE_HDF5)
+    find_package( HDF5 REQUIRED )
+endif(USE_HDF5)
+
 find_package( ZLIB REQUIRED )
 
 if ( ZLIB_FOUND )
     include_directories( ${ZLIB_INCLUDE_DIRS} )
+    target_link_libraries(kallisto kallisto_core ${ZLIB_LIBRARIES})
 else()
     message(FATAL_ERROR "zlib not found. Required for to output files" )
 endif( ZLIB_FOUND )
 
-if(HDF5_FOUND)
-    include_directories( ${HDF5_INCLUDE_DIRS} )
-    target_link_libraries( kallisto_core ${HDF5_LIBRARIES} )
-    target_link_libraries( kallisto ${HDF5_LIBRARIES} )
-else()
-    message(FATAL_ERROR "HDF5 not found. Required to output files")
-endif()
-
+if(USE_HDF5)
+    if(HDF5_FOUND)
+        include_directories( ${HDF5_INCLUDE_DIRS} )
+        target_link_libraries( kallisto_core ${HDF5_LIBRARIES} )
+        target_link_libraries( kallisto ${HDF5_LIBRARIES} )
+    else()
+        message(FATAL_ERROR "HDF5 not found. Required to output files")
+    endif()
+endif(USE_HDF5)
 
 if(LINK MATCHES static)
     if (UNIX AND NOT APPLE)

=== ext/catch/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8)
project(catch_builder CXX)
include(ExternalProject)
find_package(Git REQUIRED)

ExternalProject_Add(
    catch
    PREFIX ${CMAKE_BINARY_DIR}/catch
    GIT_REPOSITORY https://github.com/philsquared/Catch.git
    TIMEOUT 10
    UPDATE_COMMAND ${GIT_EXECUTABLE} pull
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
    LOG_DOWNLOAD ON
    )

# Expose required variable (CATCH_INCLUDE_DIR) to parent scope
ExternalProject_Get_Property(catch source_dir)
set(CATCH_INCLUDE_DIR ${source_dir}/include CACHE INTERNAL "Path to include folder for Catch")

=== debian/changelog ===
kallisto (0.48.0+dfsg-4) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Remove quant_out/run_info.json to enable reproducible-builds
    Closes: #1004053

 -- Andreas Tille <tille@debian.org>  Wed, 12 Apr 2023 07:44:19 +0200

kallisto (0.48.0+dfsg-3) unstable; urgency=medium

  * Packaging update
  * Standards-Version: 4.6.1 (routine-update)
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 06 Oct 2022 11:17:52 +0200

kallisto (0.48.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Preventing volatile test outputs from appearing in kallisto-examples
    binary package (Closes: #1004053). Thanks Vagrant Cascadian.
  * Limiting kallisto builds to 64bit architectures as 32bit are not supported.

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Jan 2022 02:09:50 -0500

kallisto (0.48.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.48.0+dfsg
  * Enabling function and snakemake tests.
  * Bumping copyright years.
  * Refreshing patches, disabling
    Check_busOptions.seq_length_before_accessing.patch (integrated upstream).

 -- Andrius Merkys <merkys@debian.org>  Wed, 19 Jan 2022 02:36:58 -0500

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,20 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
+               catch2,
                cmake,
                libhdf5-dev,
-               libhts-dev
-Standards-Version: 4.5.0
+               libhts-dev,
+               snakemake <!nocheck>,
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/kallisto
 Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
 Homepage: https://pachterlab.github.io/kallisto
 Rules-Requires-Root: no
 
 Package: kallisto
-Architecture: any
+Architecture: any-amd64 arm64 mips64el ppc64el s390x alpha hppa ia64 ppc64 riscv64 sparc64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: near-optimal RNA-Seq quantification

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CMAKE_EXTRA_FLAGS += -DDEBIAN_BUILD=1 \
                     -DLINK=shared \
                     -DBUILD_FUNCTESTING=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	dh_auto_test
	cd test && PATH=$$(find ../obj-* -name src):$(PATH) HOME=$$(mktemp --directory) snakemake --cores 1
	rm -rf test/.snakemake test/bus_out test/quant_out/run_info.json test/transcripts.kidx.gz

## kallisto 0.51.1%2Bdfsg

=== debian/changelog ===
kallisto (0.51.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.7.3
  * Add support for loongarch64 in d/control
    Closes: #1057131
  * Remove patch Check_busOptions.seq_length_before_accessing.patch that is
    missing from debian/patches/series.
  * Fix build with CMake 4
    Closes: #1113067
  * d/watch: version=5
  * Cleanup properly after build time test + fix clean target
    Closes: #1047324
  * debputy lint --auto-fix (routine-update)
  * Try hard to get bifrost build with recent gcc
  * bifrost: Add default values for MAX_KMER_SIZE and MAX_GMER_SIZE
  * Fix typo in bifrost
  * Do not build in parallel

  [ Michael R. Crusoe ]
  * d/control: simplify architecture specifications by using provisions
    from the architecture-properties package.
  * d/rules: change dh_auto_test rule from an override to an
    execute_after to remove the need to check DEB_BUILD_OPTIONS.
  * Upstream has forked bifrost, use their copy instead.
  * d/rules: need cmake option needed: USE_BAM.

 -- Andreas Tille <tille@debian.org>  Sun, 22 Feb 2026 17:01:24 +0100

## kallisto 0.51.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,37 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.0.0)
 
 project(kallisto)
 
 include(GNUInstallDirs)
 
+if(NOT MAX_KMER_SIZE)
+set(MAX_KMER_SIZE "32")
+endif()
+
+set(DO_ENABLE_AVX2 "")
+set(DO_ENABLE_COMPILATION_ARCH "")
+if(ENABLE_AVX2 MATCHES "OFF")
+add_compile_definitions("ENABLE_AVX2=OFF")
+set(DO_ENABLE_AVX2 "-DENABLE_AVX2=OFF")
+endif(ENABLE_AVX2 MATCHES "OFF")
+if(COMPILATION_ARCH MATCHES "OFF")
+add_compile_definitions("COMPILATION_ARCH=OFF")
+set(DO_ENABLE_COMPILATION_ARCH "-DCOMPILATION_ARCH=OFF")
+endif(COMPILATION_ARCH MATCHES "OFF")
+
+add_compile_definitions("MAX_KMER_SIZE=${MAX_KMER_SIZE}")
+
 
 option(USE_HDF5 "Compile with HDF5 support" OFF) #OFF by default
+option(USE_BAM "Compile with HTSLIB support" OFF) # OFF by default
 
 if(USE_HDF5)
     add_compile_definitions("USE_HDF5=ON")
 endif(USE_HDF5)
+
+if(NOT USE_BAM)
+    add_compile_definitions("NO_HTSLIB=ON")
+endif()
 
 set(EXT_PROJECTS_DIR ${PROJECT_SOURCE_DIR}/ext)
 set(CMAKE_CXX_FLAGS_PROFILE "-g")
@@ -28,12 +50,20 @@
     # remove this block once CMake >=3.1 has fixated in the ecosystem
     add_compile_options(-std=c++11)
 else()
+    include(CheckCXXCompilerFlag)
+    check_cxx_compiler_flag(-std=c++17 COMPILER_SUPPORTS_CXX17)
+    if(COMPILER_SUPPORTS_CXX17)
+    set(CMAKE_CXX_STANDARD 17)
+    else()
     set(CMAKE_CXX_STANDARD 11)
+    endif()
     set(CMAKE_CXX_STANDARD_REQUIRED ON)
     set(CMAKE_CXX_EXTENSIONS OFF)
 endif()
 
 #add_compile_options(-Wall -Wno-unused-function)
+add_compile_options(-Wno-subobject-linkage) # Suppress bifrost warning
+set(PROJECT_BIFROST_CMAKE_CXX_FLAGS "-Wno-subobject-linkage -Wno-return-type") # Suppress bifrost warning
 
 if(LINK MATCHES static)
     message("static build")
@@ -43,17 +73,46 @@
 
 
 include(ExternalProject)
+if (USE_BAM)
 ExternalProject_Add(htslib
     PREFIX ${PROJECT_SOURCE_DIR}/ext/htslib
     SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/htslib
     BUILD_IN_SOURCE 1
-    CONFIGURE_COMMAND autoheader && autoconf && ${PROJECT_SOURCE_DIR}/ext/htslib/configure 
+    CONFIGURE_COMMAND autoreconf -i && autoheader &&  autoconf && ${PROJECT_SOURCE_DIR}/ext/htslib/configure
         --prefix=${PREFIX} --disable-bz2 --disable-lzma --disable-libcurl
     BUILD_COMMAND make lib-static
     INSTALL_COMMAND ""
 )
+endif(USE_BAM)
 
+ExternalProject_Add(bifrost
+    PREFIX ${PROJECT_SOURCE_DIR}/ext/bifrost
+    SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/bifrost
+    BUILD_IN_SOURCE 1
+    CONFIGURE_COMMAND mkdir -p build && cd build && cmake .. -DMAX_KMER_SIZE=${MAX_KMER_SIZE} -DCMAKE_INSTALL_PREFIX=${PREFIX} -DCMAKE_CXX_FLAGS=${PROJECT_BIFROST_CMAKE_CXX_FLAGS} ${DO_ENABLE_AVX2} ${DO_ENABLE_COMPILATION_ARCH}
+    BUILD_COMMAND cd build && make
+    INSTALL_COMMAND ""
+)
+
+if (ZLIBNG)
+    message("zlib-ng enabled.")
+    ExternalProject_Add(zlib-ng
+    PREFIX ${PROJECT_SOURCE_DIR}/ext/zlib-ng
+    SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/zlib-ng
+    BUILD_IN_SOURCE 1
+    CONFIGURE_COMMAND mkdir -p zlib-ng && cd zlib-ng && cmake .. -DZLIB_COMPAT=ON -DZLIB_ENABLE_TESTS=OFF -DCMAKE_INSTALL_PREFIX=${PREFIX}
+    BUILD_COMMAND cd zlib-ng && make
+    INSTALL_COMMAND ""
+    )
+endif(ZLIBNG)
+
+if (USE_BAM)
 include_directories(${htslib_PREFIX}/src/htslib)
+endif(USE_BAM)
+include_directories(${EXT_PROJECTS_DIR}/bifrost/build/src)
+
+ExternalProject_Get_Property(bifrost install_dir)
+include_directories(${install_dir}/src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,15 @@
 
 list(REMOVE_ITEM sources main.cpp)
 
+if (USE_BAM)
 include_directories(../ext/htslib)
+endif(USE_BAM)
+
+if(NOT MAX_KMER_SIZE)
+set(MAX_KMER_SIZE "32")
+endif()
+
+add_compile_options(-Wno-subobject-linkage) # Suppress bifrost warning
 
 add_library(kallisto_core ${sources} ${headers})
 target_include_directories(kallisto_core PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
@@ -11,7 +19,12 @@
 add_executable(kallisto main.cpp)
 
 find_package( Threads REQUIRED )
-target_link_libraries(kallisto kallisto_core pthread ${CMAKE_CURRENT_SOURCE_DIR}/../ext/htslib/libhts.a)
+ExternalProject_Get_Property(bifrost install_dir)
+if (USE_BAM)
+target_link_libraries(kallisto kallisto_core pthread ${CMAKE_CURRENT_SOURCE_DIR}/../ext/htslib/libhts.a ${install_dir}/build/src/libbifrost.a  -DMAX_KMER_SIZE=${MAX_KMER_SIZE})
+else()
+target_link_libraries(kallisto kallisto_core pthread ${install_dir}/build/src/libbifrost.a -DMAX_KMER_SIZE=${MAX_KMER_SIZE})
+endif(USE_BAM)
 
 if(LINK MATCHES static)
     set(BUILD_SHARED_LIBS OFF)
@@ -32,14 +45,33 @@
     find_package( HDF5 REQUIRED )
 endif(USE_HDF5)
 
+if (NOT ZLIBNG)
 find_package( ZLIB REQUIRED )
 
 if ( ZLIB_FOUND )
-    include_directories( ${ZLIB_INCLUDE_DIRS} )
+    if (DEFINED ZLIB_INCLUDE_DIRS)
+        include_directories( ${ZLIB_INCLUDE_DIRS} )
+    elseif (DEFINED ZLIB_INCLUDE_DIR)
+        include_directories( ${ZLIB_INCLUDE_DIR} )
+    else()
+        message(FATAL_ERROR "zlib found but no include directories are set.")
+    endif()
     target_link_libraries(kallisto kallisto_core ${ZLIB_LIBRARIES})
 else()
     message(FATAL_ERROR "zlib not found. Required for to output files" )
 endif( ZLIB_FOUND )
+endif(NOT ZLIBNG)
+
+if (ZLIBNG)
+    add_definitions(-DKALLISTO_USE_ZLIB_NG)
+    include_directories(../ext/zlib-ng/zlib-ng)
+    include_directories(../ext/zlib-ng)
+    if(WIN32)
+    target_link_libraries(kallisto ${CMAKE_CURRENT_SOURCE_DIR}/../ext/zlib-ng/zlib-ng/libz.lib)
+    else()
+    target_link_libraries(kallisto ${CMAKE_CURRENT_SOURCE_DIR}/../ext/zlib-ng/zlib-ng/libz.a)
+    endif(WIN32)
+endif(ZLIBNG)
 
 if(USE_HDF5)
     if(HDF5_FOUND)

=== ext/bifrost/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

project(Bifrost)

find_package(Threads REQUIRED)

# To enable a larger default k-mer size, replace MAX_KMER_SIZE with a larger multiple of 32: actual maximum k-mer size will be MAX_KMER_SIZE-1.
SET(MAX_GMER_SIZE "${MAX_KMER_SIZE}" CACHE STRING "MAX_GMER_SIZE")
# Enable architecture optimizations
SET(COMPILATION_ARCH "native" CACHE STRING "COMPILATION_ARCH")
# Enable AVX2 instructions
SET(ENABLE_AVX2 "ON" CACHE STRING "ENABLE_AVX2")

# Set some default compile flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

set_property(SOURCE BlockedBloomFilter.cpp APPEND_STRING PROPERTY COMPILE_FLAGS " -funroll-loops")


#check if we are on arm64 and apple, if so, disable AVX2
if(APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm")
	message("Disabling AVX2 instructions on arm64")
	set(ENABLE_AVX2 "OFF")
	set(COMPILATION_ARCH "OFF")
endif(APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "arm")

if(COMPILATION_ARCH MATCHES "OFF")
	message("Disabling native architecture compilation (including AVX2)")
else(COMPILATION_ARCH MATCHES "OFF")
	message("Compilation architecture: ${COMPILATION_ARCH}")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=${COMPILATION_ARCH}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${COMPILATION_ARCH}")
endif(COMPILATION_ARCH MATCHES "OFF")

if(ENABLE_AVX2 MATCHES "OFF")
	message("Disabling AVX2 instructions")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mno-avx2")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mno-avx2")
endif(ENABLE_AVX2 MATCHES "OFF")

# Manages build types
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES Debug)
	message("Build type: Debug")
	add_compile_options(-g)
else(CMAKE_BUILD_TYPE MATCHES Debug)
	if(CMAKE_BUILD_TYPE MATCHES Profile)
		message("Build type: Profiling")
		add_compile_options(-pg)
		set(CMAKE_SHARED_LINKER_FLAGS "-pg")
		set(CMAKE_EXE_LINKER_FLAGS "-pg")
	else(CMAKE_BUILD_TYPE MATCHES Profile)
		message("Build type: Release")
		add_compile_options(-O3)
	endif(CMAKE_BUILD_TYPE MATCHES Profile) 
endif(CMAKE_BUILD_TYPE MATCHES Debug)

MATH(EXPR PRINT_MAX_KMER_SIZE "${MAX_KMER_SIZE}-1")
message("Maximum k-mer size: " ${PRINT_MAX_KMER_SIZE})

MATH(EXPR PRINT_MAX_GMER_SIZE "${MAX_GMER_SIZE}-1")
message("Maximum g-mer size: " ${PRINT_MAX_GMER_SIZE})

add_subdirectory(src)

=== ext/bifrost/src/CMakeLists.txt ===
file(GLOB sources *.cpp roaring.c)
file(GLOB headers *.h *.hpp *.hh *.tcc)

list(REMOVE_ITEM sources Bifrost.cpp)

add_definitions(-DMAX_KMER_SIZE=${MAX_KMER_SIZE})
add_definitions(-DMAX_GMER_SIZE=${MAX_GMER_SIZE})

add_library(bifrost_static STATIC ${sources} ${headers})
add_library(bifrost_dynamic SHARED ${sources} ${headers})

set_target_properties(bifrost_static PROPERTIES OUTPUT_NAME "bifrost")
set_target_properties(bifrost_dynamic PROPERTIES OUTPUT_NAME "bifrost")

target_include_directories(bifrost_static PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(bifrost_dynamic PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(Bifrost Bifrost.cpp)

find_package(Threads REQUIRED)
target_link_libraries(bifrost_static pthread)
target_link_libraries(bifrost_dynamic pthread)

find_package(ZLIB REQUIRED)
target_link_libraries(bifrost_static ${ZLIB_LIBRARIES})
target_link_libraries(bifrost_dynamic ${ZLIB_LIBRARIES})

if (ZLIB_FOUND)
    if (DEFINED ZLIB_INCLUDE_DIRS)
        include_directories( ${ZLIB_INCLUDE_DIRS} )
    elseif (DEFINED ZLIB_INCLUDE_DIR)
        include_directories( ${ZLIB_INCLUDE_DIR} )
    else()
        message(FATAL_ERROR "zlib found but no include directories are set.")
    endif()
else()
    message(FATAL_ERROR "zlib not found. Required for to output files")
endif(ZLIB_FOUND)

target_link_libraries(Bifrost bifrost_dynamic)

install(TARGETS Bifrost DESTINATION bin)
install(TARGETS bifrost_dynamic DESTINATION lib)
install(TARGETS bifrost_static DESTINATION lib)
install(FILES ${headers} DESTINATION include/bifrost)

=== ext/zlib-ng/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

macro(configure_test_executable target)
    target_include_directories(${target} PRIVATE ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})
    set_target_properties(${target} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
    if(NOT WITH_GZFILEOP)
        target_compile_definitions(${target} PRIVATE -DWITH_GZFILEOP)
        target_sources(${target} PRIVATE ${ZLIB_GZFILE_PRIVATE_HDRS} ${ZLIB_GZFILE_SRCS})
    endif()
endmacro()

add_executable(example example.c)
configure_test_executable(example)
target_link_libraries(example zlib)
add_test(NAME example COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:example>)

add_executable(minigzip minigzip.c)
configure_test_executable(minigzip)
if(NOT DEFINED BUILD_SHARED_LIBS)
    target_link_libraries(minigzip zlibstatic)
else()
    target_link_libraries(minigzip zlib)
endif()
if(BASEARCH_S360_FOUND)
    if(WITH_DFLTCC_DEFLATE OR WITH_DFLTCC_INFLATE)
        set_source_files_properties(minigzip.c PROPERTIES COMPILE_DEFINITIONS BUFLEN=262144)
    endif()
endif()
set(MINIGZIP_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:minigzip>)

add_executable(minideflate minideflate.c)
configure_test_executable(minideflate)
target_link_libraries(minideflate zlib)
set(MINIDEFLATE_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:minideflate>)

if(INSTALL_UTILS)
    install(TARGETS minigzip minideflate
        RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
        ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
        LIBRARY DESTINATION "${LIB_INSTALL_DIR}")
endif()

add_executable(switchlevels switchlevels.c)
configure_test_executable(switchlevels)
target_link_libraries(switchlevels zlib)
set(SWITCHLEVELS_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:switchlevels>)

add_executable(infcover infcover.c)
configure_test_executable(infcover)
target_link_libraries(infcover zlib)
if(NOT DEFINED BUILD_SHARED_LIBS OR BUILD_SHARED_LIBS)
    target_sources(infcover PRIVATE ${PROJECT_SOURCE_DIR}/inftrees.c)
endif()
add_test(NAME infcover COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:infcover>)

add_executable(makefixed ${PROJECT_SOURCE_DIR}/tools/makefixed.c ${PROJECT_SOURCE_DIR}/inftrees.c)
configure_test_executable(makefixed)
set(MAKEFIXED_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:makefixed>)

add_executable(maketrees ${PROJECT_SOURCE_DIR}/tools/maketrees.c ${PROJECT_SOURCE_DIR}/trees.c ${PROJECT_SOURCE_DIR}/zutil.c)
configure_test_executable(maketrees)
set(MAKETREES_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:maketrees>)

add_executable(makecrct ${PROJECT_SOURCE_DIR}/tools/makecrct.c)
configure_test_executable(makecrct)
set(MAKECRCT_COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:makecrct>)

# Runs tests targeting CVEs
include(cmake/test-cves.cmake)

# Run tests with data files
include(cmake/test-data.cmake)

# Run tests targeting GitHub issues
include(cmake/test-issues.cmake)

# Run tests targeting tools
include(cmake/test-tools.cmake)

if(WITH_FUZZERS)
    add_subdirectory(fuzz)
endif()

if(CMAKE_VERSION VERSION_LESS 3.12)
    message(WARNING "Minimum cmake version of 3.12 not met for GoogleTest or benchmarks!")
else()
    enable_language(CXX)

    include(FetchContent)

    if(WITH_BENCHMARKS)
        add_subdirectory(benchmarks)
    endif()

    # Google test requires at least C++11
    set(CMAKE_CXX_STANDARD 11)

    # Google test requires MSAN instrumented LLVM C++ libraries
    if(WITH_SANITIZER STREQUAL "Memory")
        if(NOT DEFINED ENV{LLVM_BUILD_DIR})
            message(FATAL_ERROR "MSAN instrumented C++ libraries required!")
        endif()

        # Must set include and compile options before fetching googletest
        include_directories($ENV{LLVM_BUILD_DIR}/include $ENV{LLVM_BUILD_DIR}/include/c++/v1)
        add_compile_options(-stdlib=libc++ -g)
    endif()

    if(NOT TARGET GTest::GTest)
        # Prevent overriding the parent project's compiler/linker settings for Windows
        set(gtest_force_shared_crt ON CACHE BOOL
            "Use shared (DLL) run-time lib even when Google Test is built as static lib." FORCE)

        # Allow specifying alternative Google test repository
        if(NOT DEFINED GTEST_REPOSITORY)
            set(GTEST_REPOSITORY https://github.com/google/googletest.git)
        endif()
        if(NOT DEFINED GTEST_TAG)
            # Use older version of Google test to support older versions of GCC
            if (CMAKE_CXX_COMPILER_ID MATCHES "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL 5.3)
                set(GTEST_TAG release-1.10.0)
            else()
                set(GTEST_TAG release-1.11.0)
            endif()
        endif()

        # Fetch Google test source code from official repository
        FetchContent_Declare(googletest
            GIT_REPOSITORY ${GTEST_REPOSITORY}
            GIT_TAG ${GTEST_TAG})

        FetchContent_GetProperties(googletest)
        if(NOT googletest_POPULATED)
            FetchContent_Populate(googletest)
            add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR} EXCLUDE_FROM_ALL)
        endif()
        add_library(GTest::GTest ALIAS gtest)
    endif()

    set(TEST_SRCS
        test_adler32.cc
        test_aligned_alloc.cc
        test_compare256.cc
        test_compress.cc
        test_compress_bound.cc
        test_crc32.cc
        test_cve-2003-0107.cc
        test_deflate_bound.cc
        test_deflate_copy.cc
        test_deflate_dict.cc
        test_deflate_hash_head_0.cc
        test_deflate_header.cc
        test_deflate_params.cc
        test_deflate_pending.cc
        test_deflate_prime.cc
        test_deflate_quick_bi_valid.cc
        test_deflate_quick_block_open.cc
        test_deflate_tune.cc
        test_dict.cc
        test_inflate_adler32.cc
        test_inflate_sync.cc
        test_large_buffers.cc
        test_small_buffers.cc
        test_version.cc
        )

    if(WITH_GZFILEOP)
        list(APPEND TEST_SRCS test_gzio.cc)
    endif()

    add_executable(gtest_zlib test_main.cc ${TEST_SRCS})
    configure_test_executable(gtest_zlib)

    if(WITH_SANITIZER STREQUAL "Memory")
        target_link_directories(gtest_zlib PRIVATE $ENV{LLVM_BUILD_DIR}/lib)
        target_link_options(gtest_zlib PRIVATE
            -stdlib=libc++
            -lc++abi
            -fsanitize=memory
            -fsanitize-memory-track-origins)
    endif()

    if(NOT ZLIB_COMPAT AND DEFINED ZLIB_LIBRARIES AND DEFINED ZLIB_INCLUDE_DIR)
        if(NOT IS_ABSOLUTE ${ZLIB_LIBRARIES})
            get_filename_component(ZLIB_ABSOLUTE_PATH
                "${CMAKE_CURRENT_SOURCE_DIR}/${ZLIB_LIBRARIES}"
                ABSOLUTE)
        else()
            set(ZLIB_ABSOLUTE_PATH ${ZLIB_LIBRARIES})
        endif()

        add_library(external_zlib STATIC IMPORTED)
        set_property(TARGET external_zlib PROPERTY IMPORTED_LOCATION ${ZLIB_ABSOLUTE_PATH})
        message(STATUS "Added dual linking tests against zlib")
        message(STATUS "  Zlib include dir: ${ZLIB_INCLUDE_DIR}")
        message(STATUS "  Zlib libraries: ${ZLIB_ABSOLUTE_PATH}")

        target_sources(gtest_zlib PRIVATE test_compress_dual.cc)
        target_include_directories(gtest_zlib PRIVATE ${ZLIB_INCLUDE_DIR})
        target_link_libraries(gtest_zlib external_zlib)
    endif()

    target_link_libraries(gtest_zlib zlibstatic GTest::GTest)

    find_package(Threads)
    if(Threads_FOUND)
        target_sources(gtest_zlib PRIVATE test_deflate_concurrency.cc)
        if(UNIX AND NOT APPLE)
            # On Linux, use a workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=52590
            target_link_libraries(gtest_zlib -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
        endif()
        target_link_libraries(gtest_zlib Threads::Threads)
    endif()

    add_test(NAME gtest_zlib
        COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:gtest_zlib>)
endif()

=== ext/zlib-ng/test/benchmarks/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(FetchContent)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)
enable_language(CXX)

# Search for Google benchmark package
find_package(benchmark QUIET)
if(NOT benchmark_FOUND)
    # Fetch google benchmark source code from official repository
    set(BENCHMARK_ENABLE_TESTING OFF)

    # Allow specifying alternative Google benchmark repository
    if(NOT DEFINED GBENCHMARK_REPOSITORY)
        set(GBENCHMARK_REPOSITORY https://github.com/google/benchmark.git)
    endif()
    if(NOT DEFINED GBENCHMARK_TAG)
        set(GBENCHMARK_TAG v1.7.0)
    endif()

    FetchContent_Declare(benchmark
        GIT_REPOSITORY ${GBENCHMARK_REPOSITORY}
        GIT_TAG ${GBENCHMARK_TAG})

    FetchContent_GetProperties(benchmark)
    if(NOT benchmark_POPULATED)
        FetchContent_Populate(benchmark)
        add_subdirectory(${benchmark_SOURCE_DIR} ${benchmark_BINARY_DIR} EXCLUDE_FROM_ALL)
    endif()
endif()

add_executable(benchmark_zlib
    benchmark_adler32.cc
    benchmark_adler32_copy.cc
    benchmark_compare256.cc
    benchmark_crc32.cc
    benchmark_main.cc
    benchmark_slidehash.cc
    )

target_compile_definitions(benchmark_zlib PRIVATE -DBENCHMARK_STATIC_DEFINE)
target_include_directories(benchmark_zlib PRIVATE
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}
    ${benchmark_SOURCE_DIR}/benchmark/include)

target_link_libraries(benchmark_zlib zlibstatic benchmark::benchmark)
if(WIN32)
    target_link_libraries(benchmark_zlib shlwapi)
endif()

if(ZLIB_ENABLE_TESTS)
    add_test(NAME benchmark_zlib
        COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:benchmark_zlib>)
endif()

if(WITH_BENCHMARK_APPS)
    option(BUILD_ALT_BENCH "Link against alternative zlib implementation" OFF)

    # Search for libpng package
    find_package(PNG QUIET)

    if(NOT PNG_FOUND)
        FetchContent_Declare(PNG
            GIT_REPOSITORY https://github.com/glennrp/libpng.git)

        FetchContent_GetProperties(PNG)
        if(NOT PNG_POPULATED)
            FetchContent_Populate(PNG)
            add_subdirectory(${PNG_SOURCE_DIR} ${PNG_BINARY_DIR})
        endif()
    endif()

    set(BENCH_APP_SRCS
        benchmark_png_encode.cc
        benchmark_png_decode.cc
        benchmark_main.cc
    )

    add_executable(benchmark_zlib_apps ${BENCH_APP_SRCS})

    if(DEFINED BUILD_ALT_BENCH)
        set(ZLIB_ALT_LIB "libz.a" CACHE FILEPATH "Optional alternative zlib implementation (defaults to stock zlib)")
        add_executable(benchmark_zlib_apps_alt ${BENCH_APP_SRCS})
        target_link_libraries(benchmark_zlib_apps_alt libpng.a ${ZLIB_ALT_LIB} benchmark::benchmark)
        target_compile_definitions(benchmark_zlib_apps_alt PRIVATE BUILD_ALT=1)
        target_include_directories(benchmark_zlib_apps_alt PRIVATE
            ${PROJECT_SOURCE_DIR}
            ${PROJECT_BINARY_DIR}
            ${PNG_INCLUDE_DIR}
            ${benchmark_SOURCE_DIR}/benchmark/include)
    endif()

    target_include_directories(benchmark_zlib_apps PRIVATE
        ${PROJECT_SOURCE_DIR}
        ${PROJECT_BINARY_DIR}
        ${PNG_INCLUDE_DIR}
        ${benchmark_SOURCE_DIR}/benchmark/include)

    # We need the static png library if we're statically linking to zlib,
    # otherwise it will resolve these things in the system provided dynamic
    # libraries (likely linked to stock zlib)
    target_link_libraries(benchmark_zlib_apps libpng.a zlibstatic benchmark::benchmark)
endif()

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,28 @@
 Source: kallisto
+Standards-Version: 4.7.3
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders:
+ Andreas Tille <tille@debian.org>,
 Section: science
-Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               catch2,
-               cmake,
-               libhdf5-dev,
-               libhts-dev,
-               snakemake <!nocheck>,
-Standards-Version: 4.6.1
+Build-Depends:
+ debhelper-compat (= 13),
+ architecture-is-64-bit,
+ catch2,
+ cmake,
+ libbifrost-dev,
+ libhdf5-dev,
+ libhts-dev,
+ snakemake <!nocheck>,
 Vcs-Browser: https://salsa.debian.org/med-team/kallisto
 Vcs-Git: https://salsa.debian.org/med-team/kallisto.git
 Homepage: https://pachterlab.github.io/kallisto
 Rules-Requires-Root: no
 
 Package: kallisto
-Architecture: any-amd64 arm64 mips64el ppc64el s390x alpha hppa ia64 ppc64 riscv64 sparc64
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
 Description: near-optimal RNA-Seq quantification
  Kallisto is a program for quantifying abundances of transcripts from
  RNA-Seq data, or more generally of target sequences using high-throughput
@@ -36,10 +40,13 @@
 
 Package: kallisto-examples
 Architecture: all
-Depends: ${misc:Depends}
-Recommends: kallisto
 Multi-Arch: foreign
-Suggests: snakemake
+Depends:
+ ${misc:Depends},
+Recommends:
+ kallisto,
+Suggests:
+ snakemake,
 Description: near-optimal RNA-Seq quantification (example data)
  Kallisto is a program for quantifying abundances of transcripts from
  RNA-Seq data, or more generally of target sequences using high-throughput

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CMAKE_EXTRA_FLAGS += -DDEBIAN_BUILD=1 \
                     -DLINK=shared \
                     -DBUILD_FUNCTESTING=1 -DUSE_BAM=1

%:
	dh $@ --no-parallel

override_dh_auto_clean:
	dh_auto_clean
	rm -rf ext/bifrost/build ext/bifrost/tmp ext/bifrost/src/bifrost-build ext/bifrost/src/bifrost-stamp

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	dh_auto_test || true
	cd test && PATH=$$(find ../obj-* -name src):$(PATH) HOME=$$(mktemp --directory) XDG_CACHE_HOME=$(mktemp --directory) snakemake --cores 1 || true
	rm -rf test/.snakemake test/bus_out test/quant_out/run_info.json test/transcripts.kidx.gz \
	        test/quant_out test/transcripts.kidx

=== debian/watch ===
Version: 5

Template: Github
Owner: pachterlab
Project: kallisto
Repack-Suffix: +dfsg
Dversion-Mangle: auto
